import java.io.*;
import junit.framework.*;

public class BinaryInputStreamTest extends TestCase {

  public void testNextBit() throws IOException {
    byte[]               buffer;
    ByteArrayInputStream bIn;
    BinaryInputStream    in;

    buffer = new byte[] {(byte)0x80, (byte)0xFF};
    bIn    = new ByteArrayInputStream(buffer);
    in     = new BinaryInputStream(bIn);

    assertTrue(in.nextBit() == 1);
    for (int i=0; i<7; i++) {
      assertTrue(in.nextBit() == 0);
    }
 
    for (int i=0; i<8; i++) {
      assertTrue(in.nextBit() == 1);
    }

    //assertTrue(in.nextBit() == 0); // EOF is followed by zeros
    assertEquals(-1, in.read());
  }

}
