import java.io.*;
import junit.framework.*;

public class BinaryOutputStreamTest extends TestCase {

  public void testByteSize() throws IOException {
    ByteArrayOutputStream bOut = new ByteArrayOutputStream();
    BinaryOutputStream    out  = new BinaryOutputStream(bOut);

    assertEquals(0, bOut.size());
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertEquals(0, bOut.size());
    assertTrue(out.writeBit(true));
    assertEquals(1, bOut.size());
    assertEquals(1, bOut.toByteArray()[0]);

    assertFalse(out.writeBit(true));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertFalse(out.writeBit(false));
    assertEquals(1, bOut.size());
    assertTrue(out.writeBit(false));
    assertEquals(2, bOut.size());
    assertEquals(Byte.MIN_VALUE, bOut.toByteArray()[1]);
  }

  public void testFlushBitBuffer() throws IOException {
    ByteArrayOutputStream bOut = new ByteArrayOutputStream();
    BinaryOutputStream    out  = new BinaryOutputStream(bOut);

    assertEquals(0, bOut.size());
    assertFalse(out.writeBit(true));
    out.flushBitBuffer();
    assertEquals(Byte.MIN_VALUE, bOut.toByteArray()[0]);
  }

}
