import java.io.*;
import java.util.*;

/**
 * Move-to-front transformation decoding code.
 */
public class M2FDecode implements Codec {

  public void processTransformation(InputStream  in,
                                    OutputStream out) throws IOException {
      int    bSize  = MAMUtil.readInt(in);
      byte[] block  = new byte[bSize];
      byte[] table  = MAMUtil.getDefaultByteOrder();
      int    avail;
      int    v;
      
      while ((avail=MAMUtil.read(in, block)) > 0) {
        for (int i=0; i<avail; i++) {
            v = block[i] - Byte.MIN_VALUE;
            adjust(table, v);
            out.write(table[0]);
        }
        out.flush();
      }
  }

  static private void adjust(byte[] table, int index) {
    if (index < 1) return;

    byte v = table[index];
    for (int i=index; i>0; i--) {
        table[i] = table[i-1];
    }
    table[0] = v;
  }

}
