import java.io.*;
import java.util.*;

public class M2FEncode implements Codec {

  private int blockSize = 30*1024*1024;

  public void processTransformation(InputStream  in,
                                    OutputStream out) throws IOException {
    byte[] block = new byte[blockSize];
    byte[] table = MAMUtil.getDefaultByteOrder();
    int    avail;

    out.write(MAMUtil.toBytes(block.length));
    while ((avail=MAMUtil.read(in, block)) > 0) {
      for (int i=0; i<avail; i++) {
          out.write(adjust(table, block[i])+Byte.MIN_VALUE);
      }
      out.flush();
    }
  }

  static private int adjust(byte[] table, byte value) {
    int  i;
    byte v;

    for (i=0; i<table.length; i++) {
        if (table[i] == value)
           break;
    }
    v = table[i];
    if (i > 0) {
       for (int j=i; j>0; j--) {
           table[j] = table[j-1];
       }
       table[0] = v;
    }
    return i;
  }

}
