import java.util.*;
import junit.framework.*;

public class MAMUtilTest extends TestCase {

  public void testIntConversions() {
    final int A = 123456789;
    final int B = -123;
    byte[]    a;

    a = MAMUtil.toBytes(A);
    assertEquals(A, MAMUtil.toInt(a));

    assertEquals(B, MAMUtil.toInt(MAMUtil.toBytes(B)));
  }

  public void testToBinaryBytes() {
    assertTrue(Arrays.equals(new byte[] {0,0,0,0,0,0,0,0},
                             MAMUtil.toBinaryBytes((byte)0x00)));
    assertTrue(Arrays.equals(new byte[] {0,0,0,0,0,0,0,1},
                             MAMUtil.toBinaryBytes((byte)0x01)));
    assertTrue(Arrays.equals(new byte[] {1,0,0,0,0,0,0,0},
                             MAMUtil.toBinaryBytes((byte)0x80)));
    assertTrue(Arrays.equals(new byte[] {1,1,1,1,1,1,1,1},
                             MAMUtil.toBinaryBytes((byte)0xFF)));
  }

}
