import java.util.*;

/**
 * An implementation of prediction by partial matching.
 */
public class PPMModel implements ArithmeticModel {

	int     maxContext = 0;
	int     context    = 0;
	int     symbols[];
	int     totalCounts[];
	PPMTree tree;

	public PPMModel()
	{
		// addNodes(str)
		// getCount(str)
		// find(str)
		// increment(str)
		
		tree = new PPMTree(3);
/*
		try {
		
		System.out.println("X");
		
		tree.addNodes(new int[] {'A', 'B', 'C'});
		tree.increment(new int[] {'A', 'B', 'C'});
		
		System.out.println("X");
		
		tree.addNodes(new int[] {'A', 'A', 'A'});
		tree.increment(new int[] {'A', 'A', 'A'});
		
		tree.addNodes(new int[] {'A', 'B', 'B'});
		tree.increment(new int[] {'A', 'B', 'B'});
		
		tree.addNodes(new int[] {'B', 'A', 'B'});
		tree.increment(new int[] {'B', 'A', 'B'});
		
		System.out.println("X");
		System.out.println(tree.root);
		
		for (Iterator it = tree.root.children.values().iterator(); it.hasNext(); )
		{
			PPMTreeNode temp = (PPMTreeNode)it.next();
			System.out.println(temp);
			
			if (temp.children.size() > 0)
			{
				for (Iterator it2 = temp.children.values().iterator(); it2.hasNext(); )
				{
					PPMTreeNode temp2 = (PPMTreeNode)it2.next();
					System.out.println(temp2);
					
					if (temp2.children.size() > 0)
						for (Iterator it3 = temp2.children.values().iterator(); it3.hasNext(); )
							System.out.println((PPMTreeNode)it3.next());
				}
			}
			
		}
		
		for (int i=0; i<tree.totalCounts.length; i++)
			System.out.println(tree.totalCounts[i]);
		
		System.out.println(tree.getCount(new int[] {'A', 'B', 'C'}));
		System.out.println(tree.getCount(new int[] {'A'}));
		
		} catch (Exception e) { System.out.println(e.getMessage()); }
*/	}

	public PPMModel(int maxContext)
	{
		symbols = new int[maxContext];
		//counts = new int[maxContext];
	}

	/**
	* Returns the low interval cumulative count of a symbol
	*/
	public long lowInterval(int symbol)
	{
		return (long)0;	
	}
	
	/**
	* Returns the high interval cumulative count of a symbol
	*/
	public long highInterval(int symbol)
	{
		return (long)0;		
	}

	/**
	* Returns the total count.
	*/
	public long totalCount()
	{
		return (long)0;		
	}

	/**
	* Informs the model with last seen symbol.
	* Model and its frequency counts are updated accordingly
	*/	
	public void updateModel(int symbol)
	{
		
/*		
		// Lets iterate through the tree and append to counts at each level
		for (int i = 0;i < maxContext; i++)
		{
			// find the symbol from tree using context=i (0,..n)
			for (int j = 0; j < i; j++)
//				node = hashtree.get( symbols[j] )
			
			totalCounts[i]++;
		}
			
			
*/		
	}

	/**
	* Return the symbol with the cumulative count
	*/	
	public int countToSymbol(int cum)
	{
		return 0;
	}

	public void reset()
	{

	}
}

// Contains the context-dependent symbol counts
//  nodes are in a hash table, which is indexed by the symbol
//
//  each node consists of (symbol, count, childtable) triplet
/**
 * Substring frequency tree
 */
class PPMTree
{
	private int        nodeCount = 0;
	public PPMTreeNode root;
	public int[]       totalCounts;

	public PPMTree(int maxContext)
	{
		totalCounts = new int[maxContext];
		root        = new PPMTreeNode();
		root.parent = root;
		root.root   = root;
	}

	// Travel through the tree and add nodes to all contexts
	public void addNodes(int[] str)
	{
		for (int i = 0; i < str.length; i++)
		{
			PPMTreeNode prev = root;
			PPMTreeNode curr = prev;
			
			for (int j = i; j < str.length; j++)
			{
			    Integer symbol = new Integer(str[j]);
			    prev = curr;
			    curr = (PPMTreeNode)curr.children.get(symbol);
			    if (curr == null) {
				PPMTreeNode temp = new PPMTreeNode(symbol.intValue(), prev);
				prev.children.put(symbol, temp);
				curr = temp;
				nodeCount++;
			    }
			}
		}
	}

	// return node or null
	public PPMTreeNode find(int[] str)
	{
		PPMTreeNode temp = root;
		for (int i = 0; i < str.length; i++)
		{
			temp = (PPMTreeNode)temp.children.get(new Integer(str[i]));
			if (temp == null)
			    return null;
		}
		return temp;
	}

	// Assume that nodes exist in the tree
	// i.e. addNodes() have been called
	public void increment(int[] str)
	{
		for (int i = 0; i < str.length; i++)
		{
			PPMTreeNode temp = root;
			for (int j = i; j < str.length; j++)
			{
				temp = (PPMTreeNode)temp.children.get(new Integer(str[j]));
			}
			temp.count++;
			totalCounts[str.length - i - 1]++; // increment also total count for context
		}
	}
	
	public int getCount(int[] str) throws Exception
	{
		PPMTreeNode temp = find(str);
		
		if (temp == null)
			throw new Exception("Count for " + Arrays.toString(str) + " not found");

		return temp.count;
	}
	
	public int getTotalCount(int context)
	{
		return totalCounts[context];
	}
}

class PPMTreeNode
{
	public int         count;
	public int         symbol;
	public int         context; // depth
	public Map         children;
	public PPMTreeNode parent;
	public PPMTreeNode root;
	
	public PPMTreeNode()
	{
		this.parent  = null;
		this.root    = null;
		this.count   = -1;
		this.symbol  = -1;
		this.context = -1;
		children     = new HashMap();
	}

	public PPMTreeNode(int symbol, PPMTreeNode parent)
	{
		this.parent  = parent;
		this.root    = parent.root;
		this.count   = 0;
		this.symbol  = symbol;
		this.context = parent.context + 1;
		children     = new HashMap();
	}
	
	public String toString()
	{
		return "Tree node with symbol " + symbol + ", context " + context + ", count " + count + ", children " + children.size();
	}
}
